// SVIctlDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SVIctl.h"
#include "SVIctlDlg.h"
#include "DumpDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSVIctlDlg _CAO

CSVIctlDlg::CSVIctlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSVIctlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSVIctlDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pReadFileThread = NULL;
}

void CSVIctlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVIctlDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSVIctlDlg, CDialog)
	//{{AFX_MSG_MAP(CSVIctlDlg)
	ON_BN_CLICKED(ID_WRITE, OnWrite)
	ON_BN_CLICKED(ID_READ, OnRead)
	ON_BN_CLICKED(ID_INIT, OnInit)
	ON_BN_CLICKED(ID_REALTIME, OnRealtime)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDOK, OnOK)
	ON_BN_CLICKED(ID_SCAN, OnScan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIctlDlg bZ[W nh

// CSV`̃p[X
bool CSVIctlDlg::ParseCsv(CString strData,vector<UCHAR> &work)
{
	if(strData.GetLength()==0)return false;

	ULONG lwork;
	PTCHAR pStopstring;
	CString strWork;
	int pos = 0;
	int count = 1;
	PTCHAR string = strData.GetBuffer(strData.GetLength());
	PTCHAR spesLine = "\r\n";		//sPʂ̕
	PTCHAR spes = " ,\t\r\n";	//s̕
	PTCHAR tokenLine,token;
	strWork = "";
	// sPʂɕ
	tokenLine = _tcstok(string,spesLine);
	while(tokenLine != NULL)
	{
		TRACE("tokenLine = %s\n",tokenLine);
		if(tokenLine[0] =='#')
		{
			tokenLine = _tcstok(NULL,spes);
			continue;
		}
		strWork += tokenLine;
		strWork += ",";
		tokenLine = _tcstok(NULL,spesLine);
	}

	tokenLine = strWork.GetBuffer(strWork.GetLength());
//	TRACE("tokenLine = %s\n",tokenLine);
//	_tcscpy(tokenLine,(LPCTSTR)strWork);
	// s̕
	token = _tcstok(tokenLine,spes);
	while(token != NULL)
	{
//		TRACE("token = %s\n",token);
		// t@CI[̐䕶Ή
		if(_tcslen(token) > 2 )
		{
			for(int i = 0 ; i < _tcslen(token);i++){
				if(!_istalnum(token[i]))
				{
					token[i] = '\0';
					break;
				}
			}
			if(_tcslen(token) < 2 )
				break;
		}
		lwork = _tcstoul(token,&pStopstring,16);
		// TCYύX
		if(work.size() <= count)
			work.resize(count);
		memcpy(&(work[count - 1]),&lwork,1);
		count++;
		token = _tcstok(NULL,spes);
	}

	return true;
}

// CSV`̃p[X t@C 2006.1.13 update >>>>>>>>>>>>>>>>>>>>>>>>>>
bool CSVIctlDlg::ParseCsv(CString strData,vector<USHORT> &work, BOOL bWord)
#if 0
{
	if(strData.GetLength()==0)return false;

	ULONG lwork;
	PTCHAR pStopstring;
	CString strWork;
	int pos = 0;
	int count = 1;
	int ptflag = 0;
	int dtflag = 0;
	int wtflag = 0;
	PTCHAR string = strData.GetBuffer(strData.GetLength());
	PTCHAR spesLine = "\r\n";		//sPʂ̕
	PTCHAR spes = " ,\t\r\n";	//s̕
	PTCHAR tokenLine,token;
	strWork = "";
	// sPʂɕ
	tokenLine = _tcstok(string,spesLine);
	while(tokenLine != NULL)
	{
		TRACE("tokenLine = %s\n",tokenLine);
		if(tokenLine[0] =='#')
		{
			tokenLine = _tcstok(NULL,spes);
			continue;
		}
		strWork += tokenLine;
		strWork += ",";
		tokenLine = _tcstok(NULL,spesLine);
	}

	tokenLine = strWork.GetBuffer(strWork.GetLength());
//	TRACE("tokenLine = %s\n",tokenLine);
//	_tcscpy(tokenLine,(LPCTSTR)strWork);
	// s̕
	token = _tcstok(tokenLine,spes);
	while(token != NULL)
	{
//		TRACE("token = %s\n",token);
		// TCYύX
		if(work.size() <= count)
			work.resize(count);
		// t@CI[̐䕶Ή
		if(_tcslen(token) > 2 )
		{
			for(int i = 0 ; i < _tcslen(token);i++){
				if(!_istalnum(token[i]))
				{
					token[i] = '\0';
					break;
				}
			}
			if(_tcslen(token) < 2 )
				break;
		}
		if(_tcsncmp(token, "wt", 2) == 0)
		{
			// pPbgwb_쐬
			work[count - 1] = 0x8100;
			count++;
			token = _tcstok(NULL,spes);
			ptflag = 1;
			wtflag = 1;
			continue;
		}
		else if(_tcsncmp(token, "none", 4) == 0)
		{
			if(work[count - (ptflag + 1)] & 0x8000)
			{
				work[count - (ptflag + 1)] &= 0xFF00;
				work[count - (ptflag + 1)] |= ptflag;
			}
			token = _tcstok(NULL,spes);
			ptflag = 0;
			continue;
		}
		// pPbgwb_쐬
		if(ptflag == 0)
		{
			work[count - 1] = 0x8000;
			count++;
			ptflag++;
			if(work.size() <= count)
				work.resize(count);
		}
		// lRs[
		lwork = _tcstoul(token,&pStopstring,16);
		if(wtflag == 1)
		{
			lwork = _tcstoul(token,&pStopstring,10);
			work[count - 1]  = (lwork < 0x8000) ? lwork : 0x7FFF;
			work[count - 2] |= 0x02;
			ptflag = 0;
			wtflag = 0;
			count++;
			token = _tcstok(NULL,spes);
			continue;
		}
		else if( (ptflag == 1) && (bWord) )
		{
			work[count - 1] = (lwork >> 8) & 0xFF00;
			count++;
			if(work.size() <= count)
				work.resize(count);
			work[count - 1] = lwork & 0xFF;
			count++;
			token = _tcstok(NULL,spes);
			dtflag = 1;
			ptflag += 2;
			continue;
		}
		else
		{
			work[count - 1] = lwork & 0xFF;
			token = _tcstok(NULL,spes);
			count++;
			ptflag++;
			if( (ptflag > 3) || ((ptflag == 3) && (dtflag == 0)) )
			{
				work[count - (ptflag + 1)] &= 0xFF00;
				work[count - (ptflag + 1)] |= (ptflag & 0xFF);
				ptflag = 0;
				dtflag = 0;
			}
		}
	}

	return true;
}
#else
// 2006.1.17 update <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
{
	if(strData.GetLength()==0)return false;

	ULONG lwork;
	PTCHAR pStopstring;
	CString strWork;
	int pos = 0;
	int count = 1;
	int pktsize = 0;
	int wtflag = 0;
	int tokenLength = 0;
	int strLength = strData.GetLength();
	LPTSTR string = strData.GetBuffer(strLength);
	LPTSTR strEnd = string + strLength;
	LPTSTR spesLine = "\r\n";		//sPʂ̕
	LPTSTR spes = " ,\t\r\n";	//s̕
	LPTSTR tokenLine,tokenLine2,token;
	strWork = "";
	// sPʂɕ
	tokenLine = _tcstok(string,spesLine);
	while(tokenLine != NULL)
	{
		TRACE("tokenLine = %s\n",tokenLine);
		if(tokenLine[0] =='#')
		{
			string += _tcslen(tokenLine) + sizeof(TCHAR);
			while((*string == '\r') || (*string == '\n'))
			{
				string++;
				if(*string == '\0') break;
			}
			tokenLine = _tcstok(NULL,spesLine);
			continue;
		}
		strWork = tokenLine;
		tokenLine2 = strWork.GetBuffer(strWork.GetLength());

		// s̕
		token = _tcstok(tokenLine2,spes);
		while(token != NULL)
		{
	//		TRACE("token = %s\n",token);
			// TCYύX
			if(work.size() <= count)
				work.resize(count);
			// t@CI[̐䕶Ή
			if(_tcslen(token) > 2 )
			{
				for(int i = 0 ; i < _tcslen(token);i++){
					if(!_istalnum(token[i]))
					{
						token[i] = '\0';
						break;
					}
				}
				if(_tcslen(token) < 2 )
					break;
			}
			// EFCgwb_
			if(_tcsncmp(token, "wt", 2) == 0)
			{
				// pPbgwb_쐬
				work[count - 1] = 0x8100;
				count++;
				token = _tcstok(NULL,spes);
				pktsize = 1;
				wtflag = 1;
				continue;
			}
			else if(_tcsncmp(token, "none", 4) == 0)
				break;

			// pPbgwb_쐬
			if(pktsize == 0)
			{
				work[count - 1] = 0x8000;
				count++;
				pktsize = 1;
				if(work.size() <= count)
					work.resize(count);
			}
			// lRs[
			lwork = _tcstoul(token,&pStopstring,16);
			if(wtflag == 1)
			{
				lwork = _tcstoul(token,&pStopstring,10);
				work[count - 1]  = (lwork < 0x8000) ? lwork : 0x7FFF;
				work[count - 2] |= 0x02;
				count++;
				pktsize++;
				break;
			}
			else if( (pktsize == 1) && (bWord) )
			{
				work[count - 1] = (lwork & 0xFF00) >> 8;
				count++;
				if(work.size() <= count)
					work.resize(count);
				work[count - 1] = lwork & 0xFF;
				count++;
				pktsize += 2;
			}
			else
			{
				work[count - 1] = lwork & 0xFF;
				count++;
				pktsize++;
			}
			token = _tcstok(NULL,spes);
		}
		work[count - (pktsize + 1)] &= 0xFF00;
		work[count - (pktsize + 1)] |= (pktsize & 0xFF);
		pktsize = 0;
		wtflag = 0;

		string += _tcslen(tokenLine) + sizeof(TCHAR);
		if(string > strEnd)
			break;
		while((*string == '\r') || (*string == '\n'))
		{
			string++;
			if(*string == '\0') break;
		}
		tokenLine = _tcstok(string, spesLine);
	}
	return true;
}
// 2006.1.17 update <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#endif

void CSVIctlDlg::OnWrite()
{

	CButton *pCheck = (CButton *)GetDlgItem(ID_WORD_ADDRESS);
	RcvBuff.clear();
	ULONG Slave,Sub;
	CString strText;
	TCHAR* Stopstring;

	// IĂSVI-03{[hݒ肵܂
	if(SetSelBoardNo() == false) return;

	// ݒl̎擾
	// Slave Address̎擾
	GetDlgItemText(ID_SLAVE_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		return;
	}
	if(!Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		return;
	}

	Slave = _tcstoul(strText,&Stopstring,16);

	// SubAddress̎擾
	GetDlgItemText(ID_SUB_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSUB);
		return;
	}
	if(!Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSUB);
		return;
	}
	Sub = _tcstoul(strText,&Stopstring,16);

	// Value̎擾
	GetDlgItemText(ID_VALUE,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTVALUE);
		return;
	}
	// Value  none ̏ꍇ  2006.01.12 update >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	if(strText.CompareNoCase( "none" ) == 0)
	{
		if(!m_SviUsbControl.SetValue(Slave,Sub,&(RcvBuff[0]),0, pCheck->GetCheck()))
		{
			AfxMessageBox(ID_MSG_ERR_WRITE);
			return;
		}
		return;
	}
	// 2006.01.12 update <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

	if(!Checkalnum((LPCTSTR)strText,true))
	{
		AfxMessageBox(ID_MSG_ERR_DATAVALUE);
		return;
	}

	// J}p[XARcvBuffɐݒ
	if(!ParseCsv(strText,RcvBuff)) return;

	// JWX^̐ݒ
	if(!m_SviUsbControl.SetValue(Slave,Sub,&(RcvBuff[0]),RcvBuff.size(), pCheck->GetCheck()))
	{
		AfxMessageBox(ID_MSG_ERR_WRITE);
		return;
	}

}

void CSVIctlDlg::OnRead()
{
	CButton *pCheck = (CButton *)GetDlgItem(ID_WORD_ADDRESS);
	RcvBuff.clear();
	ULONG Slave,Sub,Count;
#if 1 // 2012.07.24 V3.2.2.0
	CButton *pCheck2 = (CButton *)GetDlgItem(ID_RESTART_ACTIVE);
#endif // 2012.07.24 V3.2.2.0

	CString strText;
	TCHAR* Stopstring;

	// IĂSVI-03{[hݒ肵܂
	if(SetSelBoardNo() == false) return;

	// Slave Address̎擾
	GetDlgItemText(ID_SLAVE_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		return;
	}
	if(!Checkalnum((LPCTSTR)strText))
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		return;
	}
	Slave = _tcstoul(strText,&Stopstring,16);

	// SubAddress̎擾
	GetDlgItemText(ID_SUB_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_NOINPUTSUB);
		return;
	}
	if(!Checkalnum((LPCTSTR)strText))
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_DATASUB);
		return;
	}
	Sub = _tcstoul(strText,&Stopstring,16);

	BOOL Trans;
	Count = GetDlgItemInt(ID_READ_COUNTS,&Trans,TRUE);
	if(!Trans)
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_DATAREADCOUNTS);
		return;
	}
	if(Count <= 0)
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_NOINPUTREADCOUNTS);
		return;
	}

	// obt@TCYύX
	RcvBuff.resize(Count);

	// JWX^̎擾
#if 1 // 2012.07.24 V3.2.2.0
	if(!m_SviUsbControl.GetValue(Slave,Sub,&(RcvBuff[0]),Count, pCheck->GetCheck(), pCheck2->GetCheck()))
#else
	if(!m_SviUsbControl.GetValue(Slave,Sub,&(RcvBuff[0]),Count, pCheck->GetCheck()))
#endif // 2012.07.24 V3.2.2.0
	{
		CButton* button = (CButton*)GetDlgItem(ID_REALTIME);
		if(button->GetCheck())
		{
			button->SetCheck(0);
			OnRealtime();
		}
		AfxMessageBox(ID_MSG_ERR_READ);
		return;
	}
	// 擾lJ}؂`֕ҏW
	CString strRcv,strWork;
	for(int i=0;i<Count;i++)
	{
		strWork.Format("%02X",RcvBuff[i]);
		if(i!=0)
			strWork = "," + strWork;
		strRcv = strRcv + strWork;
	}

	// Read Value֕\
	GetDlgItemText(ID_DUMP_VALUE,strWork);
	strWork = strWork + strRcv;
	strWork = strWork + "\r\n";
	SetDlgItemText(ID_DUMP_VALUE,strWork);

	// ŏIsɕ\
	CEdit* pedit = (CEdit*)GetDlgItem(ID_DUMP_VALUE);
	pedit->LineScroll(pedit->GetLineCount());
}

void CSVIctlDlg::OnInit()
{

	// IĂSVI-03{[hݒ肵܂
	if(SetSelBoardNo() == false) return;

	// obt@NA
	RcvBuff.clear();

	// t@C̓Ǎ
	char szFilter[] = STR_FILE_INIFILTER;
	// t@C̎ws
	CFileDialog dlg(TRUE, NULL, NULL,
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR,
						szFilter, NULL );
	dlg.m_ofn.lpstrTitle = "t@CJ";

	// nj{^ꂽ`FbN
	if( dlg.DoModal() == IDOK )
		strRecDataFileName = dlg.GetPathName();	// t@C擾
	else
		return;

	// t@C̎擾ƍXVbZ[Wo
	// t@Cǂݍ݁AJւ̐ݒ̃Xbhグ
	pReadFileThread = AfxBeginThread(ReadFile,this);
	// Xbhグ͕\ÂB
	MsgDialog.DoModal(ID_MSG_UPDATE_DATAWRITE);

}

void CSVIctlDlg::OnOK()
{
	// ^[ɂĉʂȂ悤ɂB
	//	CDialog::OnOK();
}

void CSVIctlDlg::OnRealtime()
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* check = (CButton*)GetDlgItem(ID_REALTIME);

	// `FbNɂă^C}[ON/OFF
	if(check->GetCheck())
	{
		// IĂSVI-03{[hݒ肵܂
		if(SetSelBoardNo() == false){
			check->SetCheck(false);
			return;
		}
		SetTimer(READTIMER,TIMER_SPEED,NULL);
	}
	else
	{
		KillTimer(READTIMER);
	}
}

void CSVIctlDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	// ǂݍݏ
	if(nIDEvent == READTIMER)
			OnRead();
	CDialog::OnTimer(nIDEvent);
}

UINT CSVIctlDlg::ReadFile(LPVOID pMain)
{
#if 0
	CSVIctlDlg* main = (CSVIctlDlg*)pMain;
	CButton *pCheck = (CButton *)main->GetDlgItem(ID_WORD_ADDRESS);

	ULONG			Slave;
	vector<UCHAR>	RcvWorkBuff;
	vector<USHORT>	SetBuff;
	CString			strText;
	TCHAR*			Stopstring;
	CString			strValue;

	// ݒl̎擾
	// Slave Address̎擾
	main->GetDlgItemText(ID_SLAVE_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		goto readfile_end;
	}
	if(!main->Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		goto readfile_end;
	}

	Slave = _tcstoul(strText,&Stopstring,16);
	{
		CFile file;
		if(!file.Open(main->strRecDataFileName ,
			CFile::modeRead |
			CFile::shareExclusive |
			CFile::typeBinary))
		{
			TRACE(_T("File Open Error \n"));
			DWORD dwError = GetLastError();
			TRACE(_T("GetLastError %X\n"), dwError);
			LPVOID lpMsgBuf;
			FormatMessage(
				FORMAT_MESSAGE_ALLOCATE_BUFFER |
				FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ̌
				(LPTSTR) &lpMsgBuf,
				0,
				NULL
			);
			TRACE(_T("Error Message %s\n"), lpMsgBuf);
			LocalFree(lpMsgBuf);

			goto readfile_end;
		}

		// t@Cǂݍ(J}؂`)
		unsigned long ulFileLen = static_cast<unsigned long>(file.GetLength());
		RcvWorkBuff.resize(ulFileLen + 1);
		file.Read(&(RcvWorkBuff[0]) ,ulFileLen);
		RcvWorkBuff[ulFileLen] = '\0';
	}
	strValue = &(RcvWorkBuff[0]);
	RcvWorkBuff.clear();

	// ǂݍݏ̃p[X
	if(!main->ParseCsv(strValue,SetBuff, pCheck->GetCheck())) goto readfile_end;

	// JWX^̐ݒ
	if(!(main->m_SviUsbControl).SetValue(Slave,&(SetBuff[0]),SetBuff.size()))
	{
		AfxMessageBox(ID_MSG_ERR_INIT);
		goto readfile_end;
	}

readfile_end:
	::PostMessage(main->MsgDialog.m_hWnd,WM_CLOSE,0,0);
	return 0;
#else
	CSVIctlDlg* main = (CSVIctlDlg*)pMain;
	CButton *pCheck = (CButton *)main->GetDlgItem(ID_WORD_ADDRESS);

	ULONG			Slave;
	ULONG			Sub;
	UCHAR*			RcvWorkBuff;
	UCHAR			SetBuff[256];
	CString			strText;
	CString			strValue;
	TCHAR*			Stopstring;
	ULONG lwork;
	PTCHAR pStopstring;
	CString strWork;
	LPTSTR tokenLine,tokenLine2,token;
	int unit_f = 0;
	int wt_f = 0;
	int slave_f = 0;
	int unit = 16;
	int wt = 0;
	int slave;
	int fpos = 0;
	int bpos = 0;
	int i,j,k;
	UCHAR sendBuf[80];
	char SetItem[256];
	ULONG ulItem[20];
	unsigned long ulFileLen;
	CFile file;

	if((main->m_SviUsbControl).open() == false){
		AfxMessageBox(ID_MSG_ERR_NO_SVI03);
		goto readfile_end;
	}

	// ݒl̎擾
	// Slave Address̎擾
	main->GetDlgItemText(ID_SLAVE_ADDRESS,strText);
	strText.TrimLeft();
	strText.TrimRight();
	if(strText.GetLength()==0)
	{
		AfxMessageBox(ID_MSG_ERR_NOINPUTSLAVE);
		goto readfile_end;
	}
	if(!main->Checkalnum((LPCTSTR)strText))
	{
		AfxMessageBox(ID_MSG_ERR_DATASLAVE);
		goto readfile_end;
	}

	Slave = _tcstoul(strText,&Stopstring,16);

	if(!file.Open(main->strRecDataFileName ,
							CFile::modeRead |
							CFile::shareExclusive |
							CFile::typeBinary))
	{
		TRACE(_T("File Open Error \n"));
		AfxMessageBox(ID_MSG_ERR_FILEOPEN);
		goto readfile_end;
	}

	// t@Cǂݍ(J}؂`)
	ulFileLen = static_cast<unsigned long>(file.GetLength());
	RcvWorkBuff = new UCHAR [ulFileLen + 1];
	file.Read(RcvWorkBuff, ulFileLen);
	RcvWorkBuff[ulFileLen] = '\0';
	strValue = RcvWorkBuff;
	file.Close();

	// ɓǂݍ߂ȂG[
	if(strValue.GetLength()==0){
		TRACE(_T("File Read Error \n"));
		AfxMessageBox(ID_MSG_ERR_FILEREAD);
		goto readfile_end;
	}

	// t@ĆI2CM
	while(fpos < ulFileLen){
		// 1s擾
		for(bpos=0;fpos < ulFileLen;fpos++){
			if(RcvWorkBuff[fpos] == '\r' && RcvWorkBuff[fpos+1] == '\n'){
				SetBuff[bpos++] = '\0';
				fpos+=2;
				break;
			}
			SetBuff[bpos++] = RcvWorkBuff[fpos];
		}
		// Rgsi擪J'#'';'jXLbv
		if(SetBuff[0] == '#' || SetBuff[0] == ';' || SetBuff[0] == '\0') continue;
		// 1s
		for(i=j=k=0;i<bpos;i++){
			// s̃ACeo
			if( SetBuff[i] == ','  ||
				SetBuff[i] == ' '  || 
				SetBuff[i] == '\t' ||
				SetBuff[i] == ';'  ||
				SetBuff[i] == '#'  ||
				SetBuff[i] == '\0'){
				// 䕶i"UNIT","WT","SLAVE"j琧䏈s
				SetItem[j++] = '\0';
				if(_tcsncmp(SetItem, "UNIT", 4) == 0) unit_f = 1;
				else if(_tcsncmp(SetItem, "wt", 2) == 0) wt_f = 1;
				else if(_tcsncmp(SetItem, "WT", 2) == 0) wt_f = 1;
				else if(_tcsncmp(SetItem, "SLAVE", 5) == 0) slave_f = 1;
				else{
					if(unit_f != 0){
						sscanf(SetItem, "%d", &unit);
						unit_f = 0;
					}else if(wt_f != 0){
						if(unit == 16){
							sscanf(SetItem, "%x", &wt);
						}else{
							sscanf(SetItem, "%d", &wt);
						}
						Sleep(wt);
						wt_f = 0;
					}else if(slave_f != 0){
						if(unit == 16){
							sscanf(SetItem, "%x", &slave);
						}else{
							sscanf(SetItem, "%d", &slave);
						}
						Slave = slave;
						slave_f = 0;
					}else{
						if(SetItem[0] != NULL){
							if(unit == 16){
								sscanf(SetItem, "%x", &ulItem[k++]);
							}else{
								sscanf(SetItem, "%d", &ulItem[k++]);
							}
						}
					}
				}
				j = 0;
				if( SetBuff[i] == ';' || SetBuff[i] == '#' || SetBuff[i] == '\0') break;
			}else{
				SetItem[j++] = SetBuff[i];
			}
		}
		// I2CM
		if(k != 0){
			Sub = ulItem[0];
			TRACE("SL:%02x,SU:%04x,",Slave,Sub);
			for(i=1;i<k;i++){
				sendBuf[i-1] = (UCHAR)ulItem[i];
				TRACE("D[%d]:%02x,",i-1,sendBuf[i-1]);
			}
			TRACE("\n");
			if(!(main->m_SviUsbControl).SetValue2(Slave,Sub,sendBuf,k-1,pCheck->GetCheck())){
				AfxMessageBox(ID_MSG_ERR_INIT);
				goto readfile_end;
			}
		}
	}

readfile_end:
	::PostMessage(main->MsgDialog.m_hWnd,WM_CLOSE,0,0);
	delete [] RcvWorkBuff;

	if((main->m_SviUsbControl).close() == false){
		AfxMessageBox(ID_MSG_ERR_NO_SVI03);
		goto readfile_end;
	}

	return 0;
#endif
}

bool CSVIctlDlg::Checkalnum(LPCTSTR strText,bool cammaflg)
{
	bool rf = false;
	int len = _tcslen(strText);
	for(int i = 0;i<len;i++)
	{
		if(!_istalnum(strText[i]))
		{
			if(!cammaflg)
				return false;
			if(strText[i] != ',' )
				return false;
		}
	}
	return true;
}

BOOL CSVIctlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	// TODO: ʂȏs͂̏ꏊɒǉĂB

	//init@CeKp
	AppName = AfxGetAppName();
	IniFileName = "\\" + AppName + ".ini";
	TCHAR Path[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,Path);
	IniFileName =  Path + IniFileName;
	CIniFileControl iniFile(AppName,IniFileName);

	//	ID_SLAVE_ADDRESS
	CString slaveAddress = iniFile.getString(INI_KEY_SLAVE_ADDRESS,DEFAULT_SLAVE_ADDRESS);
	this->SetDlgItemText(ID_SLAVE_ADDRESS,slaveAddress);

	// ID_SUB_ADDRESS
	CString subAddress = iniFile.getString(INI_KEY_SUB_ADDRESS,DEFAULT_SUB_ADDRESS);
	this->SetDlgItemText(ID_SUB_ADDRESS,subAddress);

	// ID_VALUE
	CString value = iniFile.getString(INI_KEY_VALUE,DEFAULT_VALUE);
	this->SetDlgItemText(ID_VALUE,value);

	// ID_READ_COUNTS
	CString readCounts = iniFile.getString(INI_KEY_READ_COUNTS,DEFAULT_READ_COUNTS);
	this->SetDlgItemText(ID_READ_COUNTS,readCounts);

	// ID_REALTIME
	int realTime = iniFile.getInt(INI_KEY_REALTIME,DEFAULT_REALTIME);
	((CButton*)this->GetDlgItem(ID_REALTIME))->SetCheck(realTime);

	// ID_WORD_ADDRESS
	int wordAddress = iniFile.getInt(INI_KEY_WORD_ADDRESS,DEFAULT_WORD_ADDRESS);
	((CButton*)this->GetDlgItem(ID_WORD_ADDRESS))->SetCheck(wordAddress);

#if 1 // 2012.07.24 V3.2.2.0
	// ID_RESTART_ACTIVE
	int RestartConditionEnable = iniFile.getInt(INI_KEY_RESTART_ENABLE,DEFAULT_RESTART_ENABLE);
	((CButton*)this->GetDlgItem(ID_RESTART_ACTIVE))->SetCheck(RestartConditionEnable);
#endif // 2012.07.24 V3.2.2.0

	// RealTimeɃ`FbNĂ^C}[X^[g
	OnRealtime();

	// Combo{bNX|C^擾
	CComboBox* selectCombo = (CComboBox*)this->GetDlgItem(ID_SEL_COMBO);

	// 擾foCXR{{bNXɐݒ
	// ڑ䐔擾
	int connectNum = m_SviUsbControl.GetBoardNum();

	// ڑ䐔0Ȃ΃R{{bNXɐڑĂȂƕ\0ȊOȂ΃foCXID\
	if(connectNum == 0)
	{
		// R{{bNXɃG[\
		CString errorString;
		errorString.LoadString(IDS_MSG_ERR_NODEVICE);
		selectCombo->SetWindowText(errorString);
	}
	else
	{
		// ڑ䐔̃foCXR{{bNXɐݒ
		for(int i = 0; i < connectNum; i++)
		{
			// 1䂸foCXID擾
			ULONG deviceID = m_SviUsbControl.GetDeviceID(i);
			CString devIDString;			// foCXID
			//CString dipIDString;			// foCXID̃fBbvXCb`ݒID
			
			// foCXID𕶎ɕύX
			devIDString.Format("%04x",(deviceID>>16)&0xffff);
			// foCXIDBR{{bNXɐݒ
			//devIDCombo->AddString(devIDString);
			// foCXID̉SWindowsݒ肷IDȂ̂ō폜܂
			//dipIDString = devIDString.Left(4);
			// DipSwitchIDR{{bNXɕ\
			selectCombo->AddString(devIDString);
		}
		// R{{bNX̃GfBbg{bNXɃXg̐擪̒lݒ
		selectCombo->SetCurSel(0);
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CSVIctlDlg::OnClose()
{
	//AvIinit@CɌۑ

	CIniFileControl iniFile(AppName,IniFileName);

	//	ID_SLAVE_ADDRESS
	CString slaveAddress;
	this->GetDlgItemText(ID_SLAVE_ADDRESS,slaveAddress);
	iniFile.setString(INI_KEY_SLAVE_ADDRESS,slaveAddress);

	// ID_SUB_ADDRESS
	CString subAddress;
	this->GetDlgItemText(ID_SUB_ADDRESS,subAddress);
	iniFile.setString(INI_KEY_SUB_ADDRESS,subAddress);

	// ID_VALUE
	CString value;
	this->GetDlgItemText(ID_VALUE,value);
	iniFile.setString(INI_KEY_VALUE,value);

	// ID_READ_COUNTS
	CString readCounts;
	this->GetDlgItemText(ID_READ_COUNTS,readCounts);
	iniFile.setString(INI_KEY_READ_COUNTS,readCounts);

	// ID_REALTIME
	int realTime = ((CButton*)this->GetDlgItem(ID_REALTIME))->GetCheck();
	iniFile.setInt(INI_KEY_REALTIME,realTime);

	// ID_WORD_ADDRESS
	int wordAddress = ((CButton*)this->GetDlgItem(ID_WORD_ADDRESS))->GetCheck();
	iniFile.setInt(INI_KEY_WORD_ADDRESS,wordAddress);

#if 1 // 2012.07.24 V3.2.2.0
	// ID_RESTART_ACTIVE
	int RestartConditionEnable = ((CButton*)this->GetDlgItem(ID_RESTART_ACTIVE))->GetCheck();
	iniFile.setInt(INI_KEY_RESTART_ENABLE,RestartConditionEnable);
#endif // 2012.07.24 V3.2.2.0

	CDialog::OnClose();
}

void CSVIctlDlg::OnScan() 
{
	// SVI-03{[hăXL
	m_SviUsbControl.ScanBoard();

	// Combo{bNX|C^擾
	CComboBox* selectCombo = (CComboBox*)this->GetDlgItem(ID_SEL_COMBO);

	// R{{bNX̓e폜܂
	for(int i=0;i<4;i++){
		selectCombo->DeleteString(0);
	}

	// 擾foCXR{{bNXɐݒ
	// ڑ䐔擾
	int connectNum = m_SviUsbControl.GetBoardNum();

	// ڑ䐔0Ȃ΃R{{bNXɐڑĂȂƕ\0ȊOȂ΃foCXID\
	if(connectNum == 0)
	{
		// R{{bNXɃG[\
		CString errorString;
		errorString.LoadString(IDS_MSG_ERR_NODEVICE);
		selectCombo->SetWindowText(errorString);
	}
	else
	{
		// ڑ䐔̃foCXR{{bNXɐݒ
		for(int i = 0; i < connectNum; i++)
		{
			// 1䂸foCXID擾
			ULONG deviceID = m_SviUsbControl.GetDeviceID(i);
			CString devIDString;			// foCXID
			//CString dipIDString;			// foCXID̃fBbvXCb`ݒID
			
			// foCXID𕶎ɕύX
			devIDString.Format("%04x",(deviceID>>16)&0xffff);
			// foCXIDBR{{bNXɐݒ
			//devIDCombo->AddString(devIDString);
			// foCXID̉SWindowsݒ肷IDȂ̂ō폜܂
			//dipIDString = devIDString.Left(4);
			// DipSwitchIDR{{bNXɕ\
			selectCombo->AddString(devIDString);
		}
		// R{{bNX̃GfBbg{bNXɃXg̐擪̒lݒ
		selectCombo->SetCurSel(0);
	}
}

bool CSVIctlDlg::SetSelBoardNo()
{
	// 擾foCXR{{bNXɐݒ
	// ڑ䐔擾
	int connectNum = m_SviUsbControl.GetBoardNum();
	if(connectNum == 0){
		AfxMessageBox(ID_MSG_ERR_NO_SVI03);
		return false;
	}

	// Combo{bNX|C^擾
	CComboBox* selectCombo = (CComboBox*)this->GetDlgItem(ID_SEL_COMBO);

	// IĂCfbNXԍ擾܂
	int i = selectCombo->GetCurSel();

	// IꂽSVI-03ʒm܂
	m_SviUsbControl.SetSelBoardNo(i);

	return true;
}
